/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Text;


public class Evaluable extends Composite {
	private Label labelGrupo;
	private Label labelParcial;
	private Label labelTipo;
	private Label labelReferencia;
	private Label labelEnunciado;
	private Label labelPeso;
	private Label labelInicioHora;
	private Label labelFinHora;
	private Text textReferencia;public Text getTextReferencia(){return textReferencia;}
	private Text textPeso;public Text getTextPeso(){return textPeso;}
	private Text textAreaEnunciado;public Text getTextAreaEnunciado(){return textAreaEnunciado;}
	private List listEvaluables;
	private Combo comboParcial;
	private Combo comboTipo;
	private Combo comboInicioFecha;
	private Combo comboInicioHora;
	private Combo comboFinHora;
	private Combo comboFinFecha;
	private Composite compositeSeleccion;
	private Composite compositeAcciones;
	private Group groupContenido;
	private Group groupCuando;
	private Group groupInicio;
	private Group groupFin;
	private Group groupEvaluaciones;
	private Button buttonNuevo;
	private Button buttonBorrar;
	private List listEvaluacionesEstudiantes;
	private List listEvaluacionesGrupos;
	private Label labelEvaluacionesNota;
	private Text textEvaluacionesNota;public Text getTextEvaluacionesNota(){return textEvaluacionesNota;}
	private Label labelEvaluacionesObservaciones;
	private Label labelEvaluacionesMoverA;
	private Text textAreaEvaluacionesObservaciones;public Text getTextAreaEvaluacionesObservaciones(){return textAreaEvaluacionesObservaciones;}
	private Group groupEvaluacionesGrupo;
	private Group groupEvaluacionesEstudiantes;
	private Button buttonEvaluacionesNuevoGrupo;
	private Button buttonEvaluacionesBorrarGrupo;
	private Combo comboEvaluacionesMoverA;
	private ComboConId comboConIdMateriaClase;
	private ListConId listConIdEvaluables;
	private ComboConId comboConIdTipo;
	private FechaCombo fechaComboFin;
	private FechaCombo fechaComboInicio;
	private UHCombo uHComboInicio;
	private UHCombo uHComboFin;
	private ListConId listConIdEvaluacionesEstudiantes;
	private ListConId listConIdEvaluacionesGrupos;
	private Text textEvaluacionGrupoNombre;
	private Label labelReferenciaGrupo = null;
	private ComboConId comboConIdEvaluacionesMoverA;
	private Composite composite;
	private Label lblRecupera;
	private Combo comboRecupera;
	private ComboConId comboConIdEvaluableEsRecuperado;
	private Composite compositeRecupera;
	private Label lblMoverA;
	private Combo comboMoverA;
	public Text getTextEvaluacionGrupoNombre(){return textEvaluacionGrupoNombre;}
	public Evaluable(Composite parent, int style) {super(parent, style);initialize();}
	public void actualizar(){
		comboConIdMateriaClase.rellenarMateriaClase(false);
		comboConIdMateriaClase.seleccionarId(MateriaClase.getIdMateriaClaseDeTrabajo());
		comboConIdTipo.rellenarTipoEvaluable(MateriaClase.getIdMateriaDeTrabajo());		
		Parcial.rellenarParciales(comboParcial);
		rellenarParcialesMoverA();
		actualizarListaEvaluables(null);
	}
	public void rellenarParcialesMoverA(){
		comboMoverA.removeAll();
		if (comboParcial.getItemCount()>1) {
			comboMoverA.setEnabled(true);
			comboMoverA.add("");
			for (int i=0;i<comboParcial.getItemCount();i++) if (comboParcial.getSelectionIndex()!=i) comboMoverA.add(comboParcial.getItem(i));
			comboMoverA.select(0);
		} else {
			comboMoverA.setEnabled(false);
		}
	}
	private void initialize() {
		GridLayout gridLayoutEvaluable = new GridLayout();
		gridLayoutEvaluable.horizontalSpacing = 2;
		gridLayoutEvaluable.verticalSpacing = 2;
		gridLayoutEvaluable.marginWidth = 2;
		gridLayoutEvaluable.marginHeight = 2;
		gridLayoutEvaluable.numColumns = 2;
		GridData gridDataEvaluable = new GridData();
		gridDataEvaluable.grabExcessHorizontalSpace = true;
		gridDataEvaluable.grabExcessVerticalSpace = true;
		gridDataEvaluable.horizontalAlignment = GridData.FILL;
		gridDataEvaluable.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataEvaluable);
		this.setLayout(gridLayoutEvaluable);
		this.setSize(new Point(685, 340));
		createGroupSeleccion();
		createGroupCuando();
		createGroupEvaluaciones();
		createGroupContenido();
	}
	private void createGroupSeleccion() {
		GridLayout gl_compositeSeleccion = new GridLayout();
		gl_compositeSeleccion.numColumns = 3;
		gl_compositeSeleccion.verticalSpacing = 2;
		gl_compositeSeleccion.marginWidth = 2;
		gl_compositeSeleccion.marginHeight = 2;
		gl_compositeSeleccion.horizontalSpacing = 2;
		GridData gd_compositeSeleccion = new GridData();
		gd_compositeSeleccion.widthHint = 300;
		gd_compositeSeleccion.horizontalAlignment = GridData.FILL;
		gd_compositeSeleccion.grabExcessVerticalSpace = true;
		gd_compositeSeleccion.grabExcessHorizontalSpace = true;
		gd_compositeSeleccion.verticalSpan = 2;
		gd_compositeSeleccion.verticalAlignment = GridData.FILL;
		compositeSeleccion = new Composite(this, SWT.NONE);
		compositeSeleccion.setToolTipText("");
		//groupSeleccion.setText(PCuaderno.MiPCuaderno.mensajes.getString("EvaluableItem"));
		compositeSeleccion.setLayoutData(gd_compositeSeleccion);
		compositeSeleccion.setLayout(gl_compositeSeleccion);
		labelGrupo = new Label(compositeSeleccion, SWT.NONE);
		labelGrupo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelGrupo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelGroup_Text"));
		labelGrupo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelGroup_ToolTip"));
		createComboGrupoMateria();
		listEvaluables = new List(compositeSeleccion, SWT.BORDER | SWT.V_SCROLL);
		listEvaluables.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ListEvaluables_ToolTip"));
		GridData gridDataListEvaluables = new GridData();
		gridDataListEvaluables.heightHint = 100;
		gridDataListEvaluables.grabExcessVerticalSpace = true;
		gridDataListEvaluables.grabExcessHorizontalSpace = true;
		gridDataListEvaluables.widthHint = 183;
		gridDataListEvaluables.minimumHeight = 50;
		gridDataListEvaluables.horizontalAlignment = GridData.FILL;
		gridDataListEvaluables.verticalAlignment = SWT.FILL;
		gridDataListEvaluables.horizontalSpan = 2;
		gridDataListEvaluables.verticalSpan = 5;
		listEvaluables.setLayoutData(gridDataListEvaluables);
		listEvaluables
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {   
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						actualizarDatosEvaluable();
					}
				});
		listConIdEvaluables = new ListConId(listEvaluables);
		GridData gridDataLabelParcial = new GridData();
		gridDataLabelParcial.grabExcessHorizontalSpace = false;
		gridDataLabelParcial.verticalAlignment = SWT.BOTTOM;
		gridDataLabelParcial.horizontalAlignment = SWT.LEFT;
		labelParcial = new Label(compositeSeleccion, SWT.NONE);
		labelParcial.setLayoutData(gridDataLabelParcial);
		labelParcial.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelParcial_Text"));
		labelParcial.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelParcial_ToolTip"));
		GridData gridDataComboParcial = new GridData();
		gridDataComboParcial.widthHint = 50;
		gridDataComboParcial.verticalAlignment = SWT.TOP;
		gridDataComboParcial.horizontalAlignment = SWT.LEFT;
		comboParcial = new Combo(compositeSeleccion,SWT.READ_ONLY);
		comboParcial.setText("9");
		comboParcial.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ComboParcial_ToolTip"));
		comboParcial.setLayoutData(gridDataComboParcial);
		comboParcial
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Changing partial");
						actualizarListaEvaluables(null);
						listConIdEvaluables.seleccionarId(null);
						actualizarDatosEvaluable();
						rellenarParcialesMoverA();
						Parcial.setParcialDeTrabajo(comboParcial.getSelectionIndex()+1);
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		lblMoverA = new Label(compositeSeleccion, SWT.NONE);
		lblMoverA.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		lblMoverA.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LblMoverA_Text"));
		lblMoverA.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LblMoverA_ToolTip"));
		comboMoverA = new Combo(compositeSeleccion, SWT.READ_ONLY);
		GridData gd_combo = new GridData(SWT.LEFT, SWT.TOP, false, false, 1, 1);
		gd_combo.widthHint = 50;
		comboMoverA.setLayoutData(gd_combo);
		comboMoverA.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ComboMoverA_ToolTip"));
		comboMoverA
		.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Moving to partial");
				if (!comboMoverA.getItem(comboMoverA.getSelectionIndex()).equals("")) {
					Calendar fecha=null;
					int pSeleccionado=Integer.valueOf(comboMoverA.getItem(comboMoverA.getSelectionIndex()));
					if (pSeleccionado<(comboParcial.getSelectionIndex()+1)) {
					} else { 
					} 
					fecha=(Calendar)Parcial.getFechaInicioParcial(pSeleccionado).clone();
					fecha=Fecha.getFechaHoraLaboralOSiguiente(fecha, true);
					//System.out.println("insertando fecha="+Fecha.formaFechaDiaHora(fecha));
					if (fecha!=null) {
						Vector<Vector<String>> uhs = new Vector<Vector<String>>();
						uhs = BBDD.consultarUHOrdenadaMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo(),fecha.get(Calendar.DAY_OF_WEEK));
						//System.out.println("insertando uhs="+uhs);
						if (uhs!=null) if (uhs.size()>0)
							BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(), fecha, uhs.get(0).get(0), fecha, uhs.get(0).get(0));
						Fecha.fechaDeTrabajo=fecha;
					}
					comboParcial.select(Integer.valueOf(comboMoverA.getItem(comboMoverA.getSelectionIndex()))-1);
					rellenarParcialesMoverA();
					actualizarListaEvaluables(listConIdEvaluables.idSeleccionado());
					actualizarDatosEvaluable();
				}
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
		});
		GridData gd_compositeAcciones = new GridData();
		gd_compositeAcciones.horizontalAlignment = GridData.BEGINNING;
		gd_compositeAcciones.verticalAlignment = GridData.END;
		GridLayout gl_compositeAcciones = new GridLayout();
		gl_compositeAcciones.horizontalSpacing = 2;
		gl_compositeAcciones.marginWidth = 2;
		gl_compositeAcciones.marginHeight = 2;
		gl_compositeAcciones.numColumns = 1;
		gl_compositeAcciones.verticalSpacing = 2;
		compositeAcciones = new Composite(compositeSeleccion, SWT.NONE);
		compositeAcciones.setLayout(gl_compositeAcciones);
		compositeAcciones.setLayoutData(gd_compositeAcciones);
		buttonNuevo = new Button(compositeAcciones, SWT.NONE);
		buttonNuevo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Text"));
		buttonNuevo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_ToolTip"));
		buttonNuevo.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Making Evaluable");
				if (comboConIdMateriaClase.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Error_NoSubjectClass"));
				} else if (comboConIdMateriaClase.idSeleccionado()==null) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Error_NoSelSubjectClass"));
				} else if (BBDD.consultarUHvacio(MateriaClase.getIdMateriaClaseDeTrabajo())) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Error_NoSchedule"));
				} else if (comboParcial.getItemCount()==0) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Error_NoPartial"));
				} else if (comboParcial.getSelectionIndex()<0) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Error_NoSelPartial"));
				} else if (comboConIdTipo.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonNueva_Error_NoType"));
				} else {
					String tipo=comboConIdTipo.idSeleccionado();
					if (tipo==null) tipo=comboConIdTipo.primerId();
					String id=BBDD.insertarEvaluable(tipo);
					Vector<Vector<String>> evaluable=BBDD.consultarEvaluable(id);
					Calendar fecha=Fecha.fecha(evaluable.get(0).get(7), evaluable.get(0).get(6), evaluable.get(0).get(5));
					int parcial=Parcial.getParcial(fecha);
					//System.out.println("c="+(comboParcial.getSelectionIndex()+1)+" p="+parcial);
					if ((comboParcial.getSelectionIndex()+1)!=parcial) {
						comboParcial.select(parcial-1);
					}
					//System.out.println("c="+(comboParcial.getSelectionIndex()+1));
					actualizarListaEvaluables(id);
					//PCuaderno.MiPCuaderno.grupoClase.listarEstudiantesNota();
					textReferencia.setFocus();
				}
			}
		});
		buttonBorrar = new Button(compositeAcciones, SWT.NONE);
		buttonBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonBorrar_Text"));
		buttonBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonBorrar_ToolTip"));
		buttonBorrar
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("deleting Evaluable");
						Vector<Vector<String>> recuperaciones = BBDD.consultarEvaluableRecuperacionesDe(listConIdEvaluables.idSeleccionado());
						for (int i=0;i<recuperaciones.size();i++){
							BBDD.modificarEvaluableRecupera(recuperaciones.get(i).get(0), "");
						}
						BBDD.borrarEvaluable(listConIdEvaluables.idSeleccionado());
						actualizarListaEvaluables(null);
						//PCuaderno.MiPCuaderno.grupoClase.listarEstudiantesNota();
					}
				});
		
		compositeRecupera = new Composite(compositeSeleccion, SWT.NONE);
		compositeRecupera.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 4, 1));
		GridLayout gl_compositeRecupera = new GridLayout(2, false);
		gl_compositeRecupera.verticalSpacing = 0;
		gl_compositeRecupera.marginWidth = 0;
		gl_compositeRecupera.marginHeight = 0;
		gl_compositeRecupera.horizontalSpacing = 0;
		compositeRecupera.setLayout(gl_compositeRecupera);
		
		lblRecupera = new Label(compositeRecupera, SWT.NONE);
		lblRecupera.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblRecupera.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelRecupera_Text"));
		lblRecupera.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelRecupera_ToolTip"));
		
		comboRecupera = new Combo(compositeRecupera, SWT.READ_ONLY);
		GridData gd_comboRecupera = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboRecupera.widthHint = 100;
		comboRecupera.setLayoutData(gd_comboRecupera);
		comboRecupera.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ComboRecupera_ToolTip"));
		comboRecupera
			.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
				public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Fix "+listConIdEvaluables.idSeleccionado()+" remedial to "+comboConIdEvaluableEsRecuperado.idSeleccionado());
					if (comboConIdEvaluableEsRecuperado.idSeleccionado()!=null) {
						BBDD.modificarEvaluableRecupera(listConIdEvaluables.idSeleccionado(),comboConIdEvaluableEsRecuperado.idSeleccionado());
						if (!comboConIdEvaluableEsRecuperado.idSeleccionado().equals("")) {
							Vector<Vector<String>> recuperado = BBDD.consultarEvaluable(comboConIdEvaluableEsRecuperado.idSeleccionado());
							if (recuperado!=null) if (recuperado.size()>0)
							BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado()
									,Fecha.fecha(recuperado.get(0).get(3), recuperado.get(0).get(2), recuperado.get(0).get(1))
									,recuperado.get(0).get(4)
									,Fecha.fecha(recuperado.get(0).get(7), recuperado.get(0).get(6), recuperado.get(0).get(5))
									,recuperado.get(0).get(8));
							//BBDD.modificarTipoDeEvaluable(listConIdEvaluables.idSeleccionado(), recuperado.get(0).get(12));
							//BBDD.modificarEvaluablePeso(listConIdEvaluables.idSeleccionado(), recuperado.get(0).get(11));
						}
					}
					actualizarListaEvaluables(listConIdEvaluables.idSeleccionado());
				}
				public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
			});
		comboConIdEvaluableEsRecuperado=new ComboConId(comboRecupera);
	}
	private void createComboGrupoMateria() {
		GridData gridDataComboGrupoMateria = new GridData();
		gridDataComboGrupoMateria.horizontalSpan = 2;
		gridDataComboGrupoMateria.widthHint = 100;
		gridDataComboGrupoMateria.horizontalAlignment = GridData.FILL;
		gridDataComboGrupoMateria.verticalAlignment = GridData.CENTER;
		Combo comboMateriaClase = new Combo(compositeSeleccion,SWT.READ_ONLY);
		comboMateriaClase.setText("XXXXX");
		comboMateriaClase.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ComboMateriaClase_ToolTip"));
		comboMateriaClase.setLayoutData(gridDataComboGrupoMateria);
		comboMateriaClase
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Changing SubjectClass");
						MateriaClase.fijarMateriaClase(comboConIdMateriaClase.idSeleccionado());
						if (!BBDD.consultarUHvacio(comboConIdMateriaClase.idSeleccionado())){
							Parcial.rellenarParciales(comboParcial);
						} else {
							comboParcial.removeAll();
						}
						rellenarParcialesMoverA();
						comboConIdTipo.rellenarTipoEvaluable(MateriaClase.getIdMateriaDeTrabajo());
						actualizarListaEvaluables(null);
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboConIdMateriaClase = new ComboConId(comboMateriaClase);
	}
	private void createGroupContenido() {
		GridLayout gridLayoutgroupContenido = new GridLayout();
		gridLayoutgroupContenido.verticalSpacing = 2;
		gridLayoutgroupContenido.marginWidth = 2;
		gridLayoutgroupContenido.marginHeight = 2;
		gridLayoutgroupContenido.horizontalSpacing = 2;
		GridData gridDataGroupContenido = new GridData();
		gridDataGroupContenido.widthHint = 300;
		gridDataGroupContenido.minimumHeight = 50;
		gridDataGroupContenido.horizontalAlignment = GridData.FILL;
		gridDataGroupContenido.grabExcessHorizontalSpace = true;
		gridDataGroupContenido.grabExcessVerticalSpace = true;
		gridDataGroupContenido.verticalAlignment = GridData.FILL;
		groupContenido = new Group(this, SWT.NONE);
		groupContenido.setText("Contenido");
		groupContenido.setLayout(gridLayoutgroupContenido);
		groupContenido.setLayoutData(gridDataGroupContenido);
		createComboTipo();
		GridData gridDataLabelEnunciado = new GridData();
		gridDataLabelEnunciado.verticalAlignment = GridData.END;
		gridDataLabelEnunciado.horizontalAlignment = GridData.BEGINNING;
		labelEnunciado = new Label(groupContenido, SWT.NONE);
		labelEnunciado.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEnunciado_Text"));
		labelEnunciado.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEnunciado_ToolTip"));
		labelEnunciado.setLayoutData(gridDataLabelEnunciado);
		GridData gridDataTextAreaEnunciado = new GridData();
		gridDataTextAreaEnunciado.heightHint = 15;
		gridDataTextAreaEnunciado.minimumHeight = 15;
		gridDataTextAreaEnunciado.horizontalAlignment = GridData.FILL;
		gridDataTextAreaEnunciado.verticalAlignment = GridData.FILL;
		gridDataTextAreaEnunciado.grabExcessHorizontalSpace = true;
		gridDataTextAreaEnunciado.grabExcessVerticalSpace = true;
		textAreaEnunciado = new Text(groupContenido, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		textAreaEnunciado.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_TextAreaEnunciado_ToolTip"));
		textAreaEnunciado.setLayoutData(gridDataTextAreaEnunciado);
		TextoDemorado.add(textAreaEnunciado,false,512,null,null,true,listConIdEvaluables,null);
	}
	private void createComboTipo() {
		
		composite = new Composite(groupContenido, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite = new GridLayout(6, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.marginWidth = 2;
		gl_composite.marginHeight = 0;
		gl_composite.horizontalSpacing = 2;
		composite.setLayout(gl_composite);
		labelTipo = new Label(composite, SWT.NONE);
		labelTipo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelTipo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelTipo_Text"));
		labelTipo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelTipo_ToolTip"));
		comboTipo = new Combo(composite,SWT.READ_ONLY);
		GridData gd_comboTipo = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboTipo.widthHint = 20;
		comboTipo.setLayoutData(gd_comboTipo);
		comboTipo.setText("XXX");
		comboTipo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ComboTipo_ToolTip"));
		comboTipo.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("Tipo = "+comboConIdTipo.eSeleccionado()+ "("+comboConIdTipo.idSeleccionado()+")");
				BBDD.modificarTipoDeEvaluable(listConIdEvaluables.idSeleccionado(),comboConIdTipo.idSeleccionado());
				actualizarSoloListaEvaluables();
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		comboConIdTipo = new ComboConId(comboTipo);
		labelReferencia = new Label(composite, SWT.NONE);
		labelReferencia.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelReferencia.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelReferencia_Text"));
		labelReferencia.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelReferencia_ToolTip"));
		textReferencia = new Text(composite, SWT.BORDER);
		GridData gd_textReferencia = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textReferencia.widthHint = 20;
		textReferencia.setLayoutData(gd_textReferencia);
		textReferencia.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_TextReferencia_ToolTip"));
		TextoDemorado.add(textReferencia,false,8,null,null,false,listConIdEvaluables,null);
		labelPeso = new Label(composite, SWT.NONE);
		labelPeso.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelPeso.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelPeso_Text"));
		labelPeso.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelPeso_ToolTip"));
		textPeso = new Text(composite, SWT.BORDER);
		GridData gd_textPeso = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textPeso.minimumHeight = 15;
		gd_textPeso.heightHint = 15;
		gd_textPeso.widthHint = 20;
		textPeso.setLayoutData(gd_textPeso);
		textPeso.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_TextPeso_ToolTip"));
		TextoDemorado.add(textPeso,true,3,null,null,false,listConIdEvaluables,null);
	}
	private void createGroupCuando() {
		GridLayout gridLayoutGroupCuando = new GridLayout();
		gridLayoutGroupCuando.horizontalSpacing = 2;
		gridLayoutGroupCuando.marginWidth = 2;
		gridLayoutGroupCuando.marginHeight = 2;
		gridLayoutGroupCuando.numColumns = 2;
		gridLayoutGroupCuando.verticalSpacing = 2;
		GridData gridDataGroupCuando = new GridData();
		gridDataGroupCuando.widthHint = 300;
		gridDataGroupCuando.horizontalAlignment = GridData.FILL;
		gridDataGroupCuando.grabExcessHorizontalSpace = true;
		gridDataGroupCuando.verticalAlignment = GridData.FILL;
		groupCuando = new Group(this, SWT.NONE);
		groupCuando.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupCuando_Text"));
		createGroupInicio();
		groupCuando.setLayoutData(gridDataGroupCuando);
		groupCuando.setLayout(gridLayoutGroupCuando);
		createGroupFin();
	}
	private void createGroupInicio() {
		GridData gridDataGroupInicio = new GridData();
		gridDataGroupInicio.grabExcessHorizontalSpace = true;
		gridDataGroupInicio.verticalAlignment = GridData.FILL;
		gridDataGroupInicio.horizontalAlignment = GridData.FILL;
		GridLayout gridLayoutGroupInicio = new GridLayout();
		gridLayoutGroupInicio.numColumns = 2;
		gridLayoutGroupInicio.verticalSpacing = 2;
		gridLayoutGroupInicio.marginWidth = 2;
		gridLayoutGroupInicio.marginHeight = 2;
		gridLayoutGroupInicio.horizontalSpacing = 2;
		groupInicio = new Group(groupCuando, SWT.NONE);
		groupInicio.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupInicio_Text"));
		groupInicio.setLayoutData(gridDataGroupInicio);
		groupInicio.setLayout(gridLayoutGroupInicio);
		createComboInicioFecha();
		labelInicioHora = new Label(groupInicio, SWT.NONE);
		labelInicioHora.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelInicioHora_Text"));
		createComboInicioHora();
	}
	private void createComboInicioFecha() {
		GridData gridDataComboInicioFecha = new GridData();
		gridDataComboInicioFecha.horizontalAlignment = GridData.FILL;
		gridDataComboInicioFecha.grabExcessHorizontalSpace = true;
		gridDataComboInicioFecha.widthHint = 100;
		gridDataComboInicioFecha.horizontalSpan = 2;
		gridDataComboInicioFecha.verticalAlignment = GridData.CENTER;
		comboInicioFecha = new Combo(groupInicio,SWT.READ_ONLY);
		comboInicioFecha.setText("00/00/0000");
		comboInicioFecha.setLayoutData(gridDataComboInicioFecha);
		comboInicioFecha
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						uHComboInicio.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboInicio.fechaSeleccionada(),null);
						Vector<Vector<String>> evaluable = BBDD.consultarEvaluable(listConIdEvaluables.idSeleccionado());
						if (evaluable.get(0).get(15)==null)
							fechaComboFin.rellenarLectivosParcialDesdeFechaMateria(comboParcial.getSelectionIndex()+1,fechaComboInicio.fechaSeleccionada(),true);
						else
							fechaComboFin.rellenarLectivosParcialDesdeFechaMateria(null,fechaComboInicio.fechaSeleccionada(),true);
						if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
							uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
						else
							uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),null);
						BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
								fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
								fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
						actualizarListaEvaluables(null);
						Fecha.fechaDeTrabajo=fechaComboFin.fechaSeleccionada();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		fechaComboInicio = new FechaCombo(comboInicioFecha);
	}
	private void createComboInicioHora() {
		GridData gridDataComboInicioHora = new GridData();
		gridDataComboInicioHora.grabExcessHorizontalSpace = true;
		gridDataComboInicioHora.verticalAlignment = GridData.CENTER;
		gridDataComboInicioHora.widthHint = 100;
		gridDataComboInicioHora.horizontalAlignment = GridData.FILL;
		comboInicioHora = new Combo(groupInicio, SWT.READ_ONLY);
		comboInicioHora.setText("00:00-00:00");
		comboInicioHora.setLayoutData(gridDataComboInicioHora);
		comboInicioHora
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
							uHComboFin.rellenaUHMateriaClaseDesdeHora(comboConIdMateriaClase.idSeleccionado(), fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
						BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
								fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
								fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
						actualizarListaEvaluables(null);
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		uHComboInicio = new UHCombo(comboInicioHora);
	}
	private void createGroupFin() {
		GridLayout gridLayoutGroupFin = new GridLayout();
		gridLayoutGroupFin.numColumns = 2;
		gridLayoutGroupFin.verticalSpacing = 2;
		gridLayoutGroupFin.marginWidth = 2;
		gridLayoutGroupFin.marginHeight = 2;
		gridLayoutGroupFin.horizontalSpacing = 2;
		GridData gridDataGroupFin = new GridData();
		gridDataGroupFin.horizontalAlignment = GridData.FILL;
		gridDataGroupFin.grabExcessVerticalSpace = false;
		gridDataGroupFin.grabExcessHorizontalSpace = true;
		gridDataGroupFin.verticalAlignment = GridData.FILL;
		groupFin = new Group(groupCuando, SWT.NONE);
		groupFin.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupFin_Text"));
		groupFin.setLayout(gridLayoutGroupFin);
		groupFin.setLayoutData(gridDataGroupFin);
		createComboFinFecha();
		labelFinHora = new Label(groupFin, SWT.NONE);
		labelFinHora.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelFinHora_Text"));
		createComboFinHora();
	}
	private void createComboFinFecha() {
		GridData gridDataComboFinFecha = new GridData();
		gridDataComboFinFecha.horizontalAlignment = GridData.FILL;
		gridDataComboFinFecha.grabExcessHorizontalSpace = true;
		gridDataComboFinFecha.widthHint = 100;
		gridDataComboFinFecha.horizontalSpan = 2;
		gridDataComboFinFecha.verticalAlignment = GridData.CENTER;
		comboFinFecha = new Combo(groupFin, SWT.READ_ONLY);
		comboFinFecha.setText("00/00/0000");
		comboFinFecha.setLayoutData(gridDataComboFinFecha);
		comboFinFecha.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				String idMateria=comboConIdMateriaClase.idSeleccionado();
				if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
					uHComboFin.rellenaUHMateriaClaseDesdeHora(idMateria, fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
				else
					uHComboFin.rellenaUHMateriaClaseDesdeHora(idMateria, fechaComboFin.fechaSeleccionada(),null);
				BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
						fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
						fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
				actualizarSoloListaEvaluables();
				Fecha.fechaDeTrabajo=fechaComboFin.fechaSeleccionada();
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		fechaComboFin = new FechaCombo(comboFinFecha);
	}
	private void createComboFinHora() {
		GridData gridDataComboFinHora = new GridData();
		gridDataComboFinHora.horizontalAlignment = GridData.FILL;
		gridDataComboFinHora.grabExcessHorizontalSpace = true;
		gridDataComboFinHora.widthHint = 100;
		gridDataComboFinHora.verticalAlignment = GridData.CENTER;
		comboFinHora = new Combo(groupFin, SWT.READ_ONLY);
		comboFinHora.setText("00:00-00:00");
		comboFinHora.setLayoutData(gridDataComboFinHora);
		comboFinHora
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
								fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
								fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
						actualizarSoloListaEvaluables();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		uHComboFin = new UHCombo(comboFinHora);
	}
	private void createGroupEvaluaciones() {
		GridData gridDataGroupEvaluaciones = new GridData();
		gridDataGroupEvaluaciones.widthHint = 300;
		gridDataGroupEvaluaciones.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluaciones.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluaciones.grabExcessVerticalSpace = true;
		gridDataGroupEvaluaciones.verticalSpan = 2;
		gridDataGroupEvaluaciones.verticalAlignment = GridData.FILL;
		GridLayout gridLayoutGroupEvaluaciones = new GridLayout();
		gridLayoutGroupEvaluaciones.horizontalSpacing = 2;
		gridLayoutGroupEvaluaciones.marginWidth = 2;
		gridLayoutGroupEvaluaciones.marginHeight = 2;
		gridLayoutGroupEvaluaciones.numColumns = 3;
		gridLayoutGroupEvaluaciones.verticalSpacing = 2;
		groupEvaluaciones = new Group(this, SWT.NONE);
		groupEvaluaciones.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupEvaluaciones_Text"));
		groupEvaluaciones.setLayoutData(gridDataGroupEvaluaciones);
		groupEvaluaciones.setLayout(gridLayoutGroupEvaluaciones);
		createGroupEvaluacionesGrupo();
		createGroupEvaluacionesEstudiantes();
		labelEvaluacionesObservaciones = new Label(groupEvaluaciones, SWT.NONE);
		labelEvaluacionesObservaciones.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesObservaciones_Text"));
		labelEvaluacionesObservaciones.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesObservaciones_ToolTip"));
		GridData gridDataLabelEvaluacionesNota = new GridData();
		gridDataLabelEvaluacionesNota.grabExcessHorizontalSpace = true;
		gridDataLabelEvaluacionesNota.verticalAlignment = GridData.CENTER;
		gridDataLabelEvaluacionesNota.horizontalAlignment = GridData.END;
		labelEvaluacionesNota = new Label(groupEvaluaciones, SWT.NONE);
		labelEvaluacionesNota.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesNota_Text"));
		labelEvaluacionesNota.setLayoutData(gridDataLabelEvaluacionesNota);
		labelEvaluacionesNota.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesNota_ToolTip"));
		textEvaluacionesNota = new Text(groupEvaluaciones, SWT.BORDER);
		textEvaluacionesNota.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesNota_ToolTip"));
		TextoDemorado.add(textEvaluacionesNota,true,1,2,Numero.notaMax,true,listConIdEvaluacionesEstudiantes,listConIdEvaluables);
		GridData gridDataTextAreaEvaluacionesObservaciones = new GridData();
		gridDataTextAreaEvaluacionesObservaciones.minimumHeight = 15;
		gridDataTextAreaEvaluacionesObservaciones.heightHint = 15;
		gridDataTextAreaEvaluacionesObservaciones.horizontalSpan = 3;
		gridDataTextAreaEvaluacionesObservaciones.verticalAlignment = GridData.FILL;
		gridDataTextAreaEvaluacionesObservaciones.grabExcessHorizontalSpace = true;
		gridDataTextAreaEvaluacionesObservaciones.grabExcessVerticalSpace = true;
		gridDataTextAreaEvaluacionesObservaciones.horizontalAlignment = GridData.FILL;
		textAreaEvaluacionesObservaciones = new Text(groupEvaluaciones, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		textAreaEvaluacionesObservaciones.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_TextAreaEvaluacionesObservaciones_ToolTip"));
		textAreaEvaluacionesObservaciones.setLayoutData(gridDataTextAreaEvaluacionesObservaciones);
		TextoDemorado.add(textAreaEvaluacionesObservaciones,false,512,null,null,true,listConIdEvaluacionesEstudiantes,listConIdEvaluables);
	}
	private void createGroupEvaluacionesGrupo() {
		GridLayout gridLayoutGroupEvaluacionesGrupo = new GridLayout();
		gridLayoutGroupEvaluacionesGrupo.horizontalSpacing = 2;
		gridLayoutGroupEvaluacionesGrupo.marginWidth = 2;
		gridLayoutGroupEvaluacionesGrupo.marginHeight = 2;
		gridLayoutGroupEvaluacionesGrupo.numColumns = 3;
		gridLayoutGroupEvaluacionesGrupo.verticalSpacing = 2;
		GridData gridDataGroupEvaluacionesGrupo = new GridData();
		gridDataGroupEvaluacionesGrupo.widthHint = 100;
		gridDataGroupEvaluacionesGrupo.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluacionesGrupo.verticalSpan = 1;
		gridDataGroupEvaluacionesGrupo.horizontalSpan = 1;
		gridDataGroupEvaluacionesGrupo.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluacionesGrupo.verticalAlignment = GridData.FILL;
		groupEvaluacionesGrupo = new Group(groupEvaluaciones, SWT.NONE);
		groupEvaluacionesGrupo.setLayoutData(gridDataGroupEvaluacionesGrupo);
		groupEvaluacionesGrupo.setLayout(gridLayoutGroupEvaluacionesGrupo);
		groupEvaluacionesGrupo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupEvaluacionesGrupo_Text"));
		groupEvaluacionesGrupo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupEvaluacionesGrupo_ToolTip"));
		GridData gridDataListEvaluacionesGrupos = new GridData();
		gridDataListEvaluacionesGrupos.minimumHeight = 45;
		gridDataListEvaluacionesGrupos.horizontalAlignment = GridData.FILL;
		gridDataListEvaluacionesGrupos.grabExcessVerticalSpace = true;
		gridDataListEvaluacionesGrupos.horizontalSpan = 3;
		gridDataListEvaluacionesGrupos.grabExcessHorizontalSpace = true;
		gridDataListEvaluacionesGrupos.heightHint = 45;
		gridDataListEvaluacionesGrupos.widthHint = -1;
		gridDataListEvaluacionesGrupos.verticalAlignment = GridData.FILL;
		listEvaluacionesGrupos = new List(groupEvaluacionesGrupo, SWT.BORDER | SWT.V_SCROLL);
		listEvaluacionesGrupos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ListEvaluacionesGrupos_ToolTip"));
		listEvaluacionesGrupos.setLayoutData(gridDataListEvaluacionesGrupos);
		listEvaluacionesGrupos
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						actualizarNombreNuevoBorrar();
						actualizarEstudiantesEvaluacion();
						comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos,BBDD.expNoMoverGrupo);
					}
				});
		listConIdEvaluacionesGrupos = new ListConId(listEvaluacionesGrupos);
		labelReferenciaGrupo = new Label(groupEvaluacionesGrupo, SWT.NONE);
		labelReferenciaGrupo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelReferenciaGrupo_Text"));
		GridData gridDataTextEvaluacionGrupoNombre = new GridData();
		gridDataTextEvaluacionGrupoNombre.horizontalAlignment = GridData.FILL;
		gridDataTextEvaluacionGrupoNombre.grabExcessHorizontalSpace = true;
		gridDataTextEvaluacionGrupoNombre.horizontalSpan = 2;
		gridDataTextEvaluacionGrupoNombre.verticalAlignment = GridData.CENTER;
		textEvaluacionGrupoNombre = new Text(groupEvaluacionesGrupo, SWT.BORDER);
		textEvaluacionGrupoNombre.setTextLimit(10);
		textEvaluacionGrupoNombre.setLayoutData(gridDataTextEvaluacionGrupoNombre);
		TextoDemorado.add(textEvaluacionGrupoNombre,false,10,null,null,false,listConIdEvaluacionesGrupos,null);
		GridData gridDataButtonEvaluacionesNuevoGrupo = new GridData();
		gridDataButtonEvaluacionesNuevoGrupo.horizontalSpan = 2;
		buttonEvaluacionesNuevoGrupo = new Button(groupEvaluacionesGrupo, SWT.NONE);
		buttonEvaluacionesNuevoGrupo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonEvaluacionesNuevoGrupo_Text"));
		buttonEvaluacionesNuevoGrupo.setLayoutData(gridDataButtonEvaluacionesNuevoGrupo);
		buttonEvaluacionesNuevoGrupo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonEvaluacionesNuevoGrupo_ToolTip"));
		buttonEvaluacionesNuevoGrupo
		.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Making Evaluable");
				String idEval = BBDD.consultarIdEvalEstudianteEvaluable(
						listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado());
				int nEstudiantes = listConIdEvaluacionesEstudiantes.idSeleccionados().size();
				for (int i=1;i<nEstudiantes;i++) {
					BBDD.borrarEvalEvaluable(BBDD.consultarIdEvalEstudianteEvaluable(
							listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),
							listConIdEvaluables.idSeleccionado()));
				}
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("New group from "+idEval);
				if (idEval!=null) {
					BBDD.modificarGrupoEvalEvaluable(BBDD.expNuevoGrupoEvaluacion, idEval);
					for (int i=1;i<nEstudiantes;i++){
						BBDD.insertarEstudianteGrupoEvalEvaluable(listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),idEval);
					}
				} else {
					idEval = BBDD.insertarEvalEstudianteEvaluable(
							listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado(), 
							"0");
					BBDD.modificarGrupoEvalEvaluable(BBDD.expNuevoGrupoEvaluacion, idEval);
					for (int i=1;i<nEstudiantes;i++){
						BBDD.insertarEstudianteGrupoEvalEvaluable(listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),idEval);
					}
				}
				actualizarGrupoEvaluacion();
				listConIdEvaluacionesGrupos.seleccionarId(idEval);
				actualizarNombreNuevoBorrar();
				actualizarEstudiantesEvaluacion();
				comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos,BBDD.expNoMoverGrupo);
			}
		});
		GridData gridDataButtonEvaluacionesBorrarGrupo = new GridData();
		gridDataButtonEvaluacionesBorrarGrupo.horizontalAlignment = GridData.END;
		gridDataButtonEvaluacionesBorrarGrupo.verticalAlignment = GridData.CENTER;
		buttonEvaluacionesBorrarGrupo = new Button(groupEvaluacionesGrupo, SWT.NONE);
		buttonEvaluacionesBorrarGrupo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonEvaluacionesBorrarGrupo_Text"));
		buttonEvaluacionesBorrarGrupo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ButtonEvaluacionesBorrarGrupo_ToolTip"));
		buttonEvaluacionesBorrarGrupo.setLayoutData(gridDataButtonEvaluacionesBorrarGrupo);
		buttonEvaluacionesBorrarGrupo
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Delete group");
						BBDD.borrarEvalEvaluable(BBDD.consultarIdEvalEstudianteEvaluable(
								listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado()));
						actualizarGrupoEvaluacion();
					}
				});
	}
	private void createGroupEvaluacionesEstudiantes() {
		GridLayout gridLayoutGroupEvaluacionesEstudiantes = new GridLayout();
		gridLayoutGroupEvaluacionesEstudiantes.horizontalSpacing = 2;
		gridLayoutGroupEvaluacionesEstudiantes.marginWidth = 2;
		gridLayoutGroupEvaluacionesEstudiantes.marginHeight = 2;
		gridLayoutGroupEvaluacionesEstudiantes.numColumns = 1;
		gridLayoutGroupEvaluacionesEstudiantes.verticalSpacing = 2;
		GridData gridDataGroupEvaluacionesEstudiantes = new GridData();
		gridDataGroupEvaluacionesEstudiantes.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluacionesEstudiantes.verticalSpan = 1;
		gridDataGroupEvaluacionesEstudiantes.horizontalSpan = 2;
		gridDataGroupEvaluacionesEstudiantes.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluacionesEstudiantes.grabExcessVerticalSpace = true;
		gridDataGroupEvaluacionesEstudiantes.widthHint = 175;
		gridDataGroupEvaluacionesEstudiantes.verticalAlignment = GridData.FILL;
		groupEvaluacionesEstudiantes = new Group(groupEvaluaciones, SWT.NONE);
		groupEvaluacionesEstudiantes.setLayoutData(gridDataGroupEvaluacionesEstudiantes);
		groupEvaluacionesEstudiantes.setLayout(gridLayoutGroupEvaluacionesEstudiantes);
		groupEvaluacionesEstudiantes.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_GroupEvaluacionesEstudiantes_Text"));
		GridData gridDataListEvaluacionesEstudiantes = new GridData();
		gridDataListEvaluacionesEstudiantes.minimumHeight = 45;
		gridDataListEvaluacionesEstudiantes.grabExcessHorizontalSpace = true;
		gridDataListEvaluacionesEstudiantes.horizontalAlignment = GridData.FILL;
		gridDataListEvaluacionesEstudiantes.verticalAlignment = GridData.FILL;
		gridDataListEvaluacionesEstudiantes.grabExcessVerticalSpace = true;
		gridDataListEvaluacionesEstudiantes.heightHint = 45;
		listEvaluacionesEstudiantes = new List(groupEvaluacionesEstudiantes, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		listEvaluacionesEstudiantes.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ListEvaluacionesEstudiantes_ToolTip"));
		listEvaluacionesEstudiantes.setLayoutData(gridDataListEvaluacionesEstudiantes);
		listEvaluacionesEstudiantes.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				actualizarNotaObservaciones();
			}
		});
		listConIdEvaluacionesEstudiantes = new ListConId(listEvaluacionesEstudiantes);
		GridData gridDataLabelEvaluacionesMoverA = new GridData();
		gridDataLabelEvaluacionesMoverA.horizontalAlignment = GridData.END;
		gridDataLabelEvaluacionesMoverA.verticalAlignment = GridData.CENTER;
		labelEvaluacionesMoverA = new Label(groupEvaluacionesEstudiantes, SWT.NONE);
		labelEvaluacionesMoverA.setText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesMoverA_Text"));
		labelEvaluacionesMoverA.setLayoutData(gridDataLabelEvaluacionesMoverA);
		labelEvaluacionesMoverA.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_LabelEvaluacionesMoverA_ToolTip"));
		createComboEvaluacionesMoverA();
	}
	private void createComboEvaluacionesMoverA() {
		GridData gridDataComboEvaluacionesMoverA = new GridData();
		gridDataComboEvaluacionesMoverA.widthHint = 100;
		gridDataComboEvaluacionesMoverA.horizontalAlignment = GridData.FILL;
		gridDataComboEvaluacionesMoverA.verticalAlignment = GridData.CENTER;
		gridDataComboEvaluacionesMoverA.grabExcessHorizontalSpace = true;
		comboEvaluacionesMoverA = new Combo(groupEvaluacionesEstudiantes, SWT.READ_ONLY);
		comboEvaluacionesMoverA.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Evaluable_ComboEvaluacionesMoverA_ToolTip"));
		comboEvaluacionesMoverA.setLayoutData(gridDataComboEvaluacionesMoverA);
		comboConIdEvaluacionesMoverA = new ComboConId(comboEvaluacionesMoverA);
		comboEvaluacionesMoverA
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Mover to group");
						if (comboEvaluacionesMoverA.getSelectionIndex()>=0)
							if (comboConIdEvaluacionesMoverA.idSeleccionado().equals("")
									&& comboConIdEvaluacionesMoverA.eSeleccionado().equals(BBDD.expNoMoverGrupo)) {
								comboEvaluacionesMoverA.select(-1);
							} else {
								if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Moving to group "+comboConIdEvaluacionesMoverA.eSeleccionado()+"("+comboConIdEvaluacionesMoverA.idSeleccionado()+") from "+BBDD.expSinGrupoEvaluacion);
								String idEval = BBDD.consultarIdEvalEstudianteEvaluable(
										listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado());
								// De donde viene quitar o borrar si viene de algun lado
								if (idEval!=null) {
									Vector<Vector<String>> estudiantes = BBDD.consultarEstudiantesEvalEvaluable(listConIdEvaluacionesGrupos.idSeleccionado());
									int ne = listConIdEvaluacionesEstudiantes.idSeleccionados().size();
									if (estudiantes.size()>ne) {
										for (int i=0;i<ne;i++){
											BBDD.borrarEstudianteGrupoEvalEvaluable(
													listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),
													listConIdEvaluacionesGrupos.idSeleccionado());
										}
									} else {
										BBDD.borrarEvalEvaluable(idEval);
										actualizarGrupoEvaluacion();
									}
								}
								// A donde va insertar
								idEval = comboConIdEvaluacionesMoverA.idSeleccionado();
								if (idEval==null) idEval="";// Va a sin grupo
								if (idEval.equals("")) {
									// Va a sin grupo se queda sin evaluación
								} else {
									int ne = listConIdEvaluacionesEstudiantes.idSeleccionados().size();
									for (int i=0;i<ne;i++){
										BBDD.insertarEstudianteGrupoEvalEvaluable(listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),idEval);
									}
								}
								listConIdEvaluacionesGrupos.seleccionarId(idEval);
								actualizarNombreNuevoBorrar();
								actualizarEstudiantesEvaluacion();
								comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos,BBDD.expNoMoverGrupo);
							}
					}
					public void widgetDefaultSelected(
							org.eclipse.swt.events.SelectionEvent e) {
					}
				});
	}
	public void actualizarListaEvaluables(String idSeleccionado){
		if (comboConIdMateriaClase.idSeleccionado()!=null && comboParcial.getSelectionIndex()>=0){
			actualizarSoloListaEvaluables();
			listConIdEvaluables.seleccionarId(idSeleccionado);
		} else {
			listConIdEvaluables.borrar();
		}
		actualizarDatosEvaluable(); 
	}
	public void actualizarSoloListaEvaluables(){
		//System.out.println("actualiza");
		listConIdEvaluables.rellenarEvaluables(comboConIdMateriaClase.idSeleccionado(),comboParcial.getSelectionIndex()+1);
	}
	private void actualizarDatosEvaluable(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Update assessable data");
		if (listConIdEvaluables.idSeleccionado()==null){
			comboConIdEvaluableEsRecuperado.borrar();comboConIdEvaluableEsRecuperado.deshabilitar();
			textReferencia.setEnabled(false);textReferencia.setText("");
			textPeso.setEnabled(false);textPeso.setText("");
			textAreaEnunciado.setEnabled(false);textAreaEnunciado.setText("");
			textAreaEvaluacionesObservaciones.setEnabled(false);textAreaEvaluacionesObservaciones.setText("");
			textEvaluacionesNota.setEnabled(false);textEvaluacionesNota.setText("");
			comboConIdTipo.deshabilitar();
			fechaComboInicio.seleccionarPrimera();
			fechaComboInicio.deshabilitar();
			fechaComboFin.borrar();uHComboInicio.getCombo().setEnabled(false);
			uHComboInicio.borrar();fechaComboFin.deshabilitar();
			uHComboFin.borrar();uHComboFin.getCombo().setEnabled(false);
			listConIdEvaluacionesEstudiantes.deshabilitar();
			listConIdEvaluacionesGrupos.borrar();listConIdEvaluacionesGrupos.deshabilitar();
			textEvaluacionGrupoNombre.setEnabled(false);textEvaluacionGrupoNombre.setText("");
			comboEvaluacionesMoverA.setEnabled(false);
			buttonEvaluacionesBorrarGrupo.setEnabled(false);
			buttonEvaluacionesNuevoGrupo.setEnabled(false);
			buttonBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> evaluable;
			TextoDemorado.escribeSiHay();
			evaluable=BBDD.consultarEvaluable(listConIdEvaluables.idSeleccionado());
			String idEvaluable=evaluable.get(0).get(0);
			String idEvaluableEsRecuperado=evaluable.get(0).get(15);
			Vector<Vector<String>> evaluableEsrecuperado = null;
			if (idEvaluableEsRecuperado!=null)
				evaluableEsrecuperado = BBDD.consultarEvaluable(idEvaluableEsRecuperado);
			Vector<Vector<String>> evaluablesRecuperaciones = BBDD.consultarEvaluableRecuperacionesDe(idEvaluable);
			comboConIdEvaluableEsRecuperado.borrar();comboConIdEvaluableEsRecuperado.deshabilitar();
			//System.out.println("recuperada="+recuperada);
			if (evaluablesRecuperaciones==null || evaluablesRecuperaciones.size()==0) {
				comboConIdEvaluableEsRecuperado.rellenarConEvaluablesNoRecuNoSeleLista(comboConIdMateriaClase.idSeleccionado(),comboParcial.getSelectionIndex()+1,listConIdEvaluables);
				comboConIdEvaluableEsRecuperado.habilitar();
				//System.out.println("recupera="+evaluable.get(0).get(15));
				//BBDD.imprimir(evaluable);
				if (evaluableEsrecuperado==null)
					comboConIdEvaluableEsRecuperado.seleccionarPrimero();
				else 
					comboConIdEvaluableEsRecuperado.seleccionarId(idEvaluableEsRecuperado);
			}
			if (idEvaluableEsRecuperado==null)
				fechaComboInicio.rellenarLectivosParcialDesdeFechaMateria(comboParcial.getSelectionIndex()+1,null, true);
			else {
				fechaComboInicio.rellenarLectivosParcialDesdeFechaMateria(null,Fecha.fecha(evaluableEsrecuperado.get(0).get(7),evaluableEsrecuperado.get(0).get(6),evaluableEsrecuperado.get(0).get(5)), true);
			}
			TextoDemorado.modificaSinActualizar(textReferencia,evaluable.get(0).get(9));
			if (idEvaluableEsRecuperado==null)
				TextoDemorado.modificaSinActualizar(textPeso,evaluable.get(0).get(11));
			else {
				TextoDemorado.modificaSinActualizar(textPeso,evaluableEsrecuperado.get(0).get(11));
				textPeso.setEnabled(false);
			}
			if (idEvaluableEsRecuperado==null) {
				comboConIdTipo.seleccionarId(evaluable.get(0).get(12));
				comboTipo.setEnabled(true);
			} else {
				comboConIdTipo.seleccionarId(evaluableEsrecuperado.get(0).get(12));
				comboTipo.setEnabled(false);
			}
			TextoDemorado.modificaSinActualizar(textAreaEnunciado,evaluable.get(0).get(10));textAreaEnunciado.setEnabled(true);
			//System.out.println("actualizarDatosEvaluable fecha "+Fecha.formaFecha(evaluable.get(0).get(3),evaluable.get(0).get(2),evaluable.get(0).get(1)));
			fechaComboInicio.seleccionarFecha(Fecha.fecha(evaluable.get(0).get(3),evaluable.get(0).get(2),evaluable.get(0).get(1)));
			fechaComboInicio.habilitar();
			uHComboInicio.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboInicio.fechaSeleccionada(),null);
			uHComboInicio.seleccionarId(evaluable.get(0).get(4));
			uHComboInicio.getCombo().setEnabled(true);
			if (idEvaluableEsRecuperado==null)
				fechaComboFin.rellenarLectivosParcialDesdeFechaMateria(comboParcial.getSelectionIndex()+1,fechaComboInicio.fechaSeleccionada(),true);
			else
				fechaComboFin.rellenarLectivosParcialDesdeFechaMateria(null,fechaComboInicio.fechaSeleccionada(),true);
			fechaComboFin.seleccionarFecha(Fecha.fecha(evaluable.get(0).get(7),evaluable.get(0).get(6),evaluable.get(0).get(5)));
			fechaComboFin.habilitar();
			if (fechaComboInicio.fechaSeleccionada()==null || fechaComboFin.fechaSeleccionada()==null) {
				uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),null);
			} else {
				if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
					uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
				else
					uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),null);
			}
			uHComboFin.seleccionarId(evaluable.get(0).get(8));
			uHComboFin.getCombo().setEnabled(true);
			actualizarGrupoEvaluacion();
			listConIdEvaluacionesGrupos.habilitar();
			listConIdEvaluacionesEstudiantes.habilitar();
			actualizarNotaObservaciones();
			buttonBorrar.setEnabled(true);
			//System.out.println("Evaluable Mat ("+idMateria+"): ini "+Fecha.formaFecha(evaluable.get(0).get(3),evaluable.get(0).get(2),evaluable.get(0).get(1))+" - "+evaluable.get(0).get(4)+
			//		", fin "+Fecha.formaFecha(evaluable.get(0).get(7),evaluable.get(0).get(6),evaluable.get(0).get(5))+" - "+evaluable.get(0).get(8));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("END");
	}
	private void actualizarEstudiantesEvaluacion(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Update students");
		if (listConIdEvaluacionesGrupos.idSeleccionado()!=null){
			listConIdEvaluacionesEstudiantes.rellenarEstudiantesGrupoEval(listConIdEvaluables.idSeleccionado(),listConIdEvaluacionesGrupos.idSeleccionado());
		} else {
			listConIdEvaluacionesEstudiantes.borrar();
		}
		actualizarNotaObservaciones();
	}
	public void actualizarGrupoEvaluacion(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Update groups");
		String idAntiguo = listConIdEvaluacionesGrupos.idSeleccionado();
		listConIdEvaluacionesGrupos.borrar();
		listConIdEvaluacionesGrupos.rellenarGrupoEvalEvaluable(listConIdEvaluables.idSeleccionado());
		if (idAntiguo!=null) listConIdEvaluacionesGrupos.seleccionarId(idAntiguo);
		actualizarNombreNuevoBorrar();
		actualizarEstudiantesEvaluacion();
		comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos,BBDD.expNoMoverGrupo);
		if (comboConIdEvaluacionesMoverA.numeroElementos()>0) comboConIdEvaluacionesMoverA.habilitar(); 
		else comboConIdEvaluacionesMoverA.deshabilitar();
	}
	public void actualizarNotaObservaciones(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Update marks "+listConIdEvaluacionesEstudiantes.idSeleccionados().size()+" students");
		if (listConIdEvaluacionesEstudiantes.idSeleccionados().size()>1) {
			TextoDemorado.modificaSinActualizar(textEvaluacionesNota, "");
			textEvaluacionesNota.setEnabled(false);
		} else {
			textEvaluacionesNota.setEnabled(true);
			String nota = BBDD.consultarEvalNota(listConIdEvaluables.idSeleccionado(),listConIdEvaluacionesEstudiantes.idSeleccionado());
			if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("mark = "+nota);
			if (nota!=null) {
				TextoDemorado.modificaSinActualizar(textEvaluacionesNota,Numero.cadenaDecimal(Double.parseDouble(nota)));
				TextoDemorado.modificaSinActualizar(textAreaEvaluacionesObservaciones,
						BBDD.consultarEvalObservaciones(listConIdEvaluables.idSeleccionado(),listConIdEvaluacionesEstudiantes.idSeleccionado()));
			} else {
				TextoDemorado.modificaSinActualizar(textEvaluacionesNota,"");
				TextoDemorado.modificaSinActualizar(textAreaEvaluacionesObservaciones, "");textAreaEvaluacionesObservaciones.setEnabled(false);
			}
		}
	}
	private void actualizarNombreNuevoBorrar(){ // Sin grupo => id=""
		if (((listConIdEvaluacionesGrupos.idSeleccionado()==null)?true:listConIdEvaluacionesGrupos.idSeleccionado().isEmpty())){
			TextoDemorado.modificaSinActualizar(textEvaluacionGrupoNombre,"");
			textEvaluacionGrupoNombre.setEnabled(false);
			buttonEvaluacionesBorrarGrupo.setEnabled(false);
			buttonEvaluacionesNuevoGrupo.setEnabled(true);
		} else {
			TextoDemorado.modificaSinActualizar(textEvaluacionGrupoNombre,listConIdEvaluacionesGrupos.elementoSeleccionado());
			buttonEvaluacionesBorrarGrupo.setEnabled(true);
			buttonEvaluacionesNuevoGrupo.setEnabled(false);
		}
	}
}
