/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

public class MateriaClase {
	private static String idMateriaClaseDeTrabajo;
	private static String idMateriaDeTrabajo;
	private static String idClaseDeTrabajo;
	private static String idEnsenanzaDeTrabajo;
	private static String idTituloDeTrabajo;
	private static String idNivelDeTrabajo;
	public static void inicializar(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");;
		if (!BBDD.consultarUHvacio(null)) {
			String idMateriaClase=BBDD.consultarIdMateriaClaseParaFechaHora(Fecha.fechaDeTrabajo);
			if (idMateriaClase!=null) MateriaClase.fijarMateriaClase(idMateriaClase);
			else MateriaClase.fijarMateriaClase(BBDD.consultarIdMateriaClasePrimera());
		} else MateriaClase.fijarMateriaClase(BBDD.consultarIdMateriaClasePrimera());
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("MateriaClaseDeTrabajo = "+MateriaClase.idMateriaClaseDeTrabajo+".");
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("MateriaDeTrabajo = "+MateriaClase.idMateriaDeTrabajo+".");
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("ClaseDeTrabajo = "+MateriaClase.idClaseDeTrabajo+".");
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end");;
	}
	public static String getIdMateriaClaseDeTrabajo() {return idMateriaClaseDeTrabajo;}
	public static String getIdMateriaDeTrabajo() {return idMateriaDeTrabajo;}
	public static String getIdClaseDeTrabajo() {return idClaseDeTrabajo;}
	public static String getIdEnsenanzaDeTrabajo() {return idEnsenanzaDeTrabajo;}
	public static String getIdTituloDeTrabajo() {return idTituloDeTrabajo;}
	public static String getIdNivelDeTrabajo() {return idNivelDeTrabajo;}
	public static String getIdMateriaClase(String idMateria,String idClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+")");;
		String resultado=null;
		if (idMateria!=null && idClase!=null) {
			Vector<String> registro = BBDD.consultarIdMateriaClase(idMateria, idClase);
			if (registro!=null) if (registro.size()>0) resultado=registro.get(0);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+") "+resultado);;
		return resultado;
	}
	public static String formaClase(String idClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idClase+")");
		String resultado=null;
		if (idClase!=null) if (!idClase.isEmpty()) {
			Vector<Vector<String>> tabla = BBDD.consultarClase(null,idClase);
			if (tabla!=null) if (tabla.size()>0) {
				resultado=tabla.get(0).get(1)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")
						+tabla.get(0).get(2)+" "+tabla.get(0).get(3);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idClase+") "+resultado);;
		return resultado;
	}
	public static void fijarMateriaClase(String idMateriaClase) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateriaClase+")");
		Vector<String> mc = BBDD.consultarIdMateriaClase(idMateriaClase);
		//BBDD.imprimirRegistro(mc);
		if (mc==null || mc.size()==0) {
			MateriaClase.idMateriaClaseDeTrabajo=null;
			MateriaClase.idMateriaDeTrabajo=null;
			MateriaClase.idClaseDeTrabajo=null;
			MateriaClase.idNivelDeTrabajo=null;
			MateriaClase.idTituloDeTrabajo=null;
			MateriaClase.idEnsenanzaDeTrabajo=null;
			Parcial.defParciales();
			Fecha.actualizarDiasNoLectivosClase();
			//Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(),false);
		} else {
			MateriaClase.idMateriaClaseDeTrabajo=mc.get(0);
			MateriaClase.idMateriaDeTrabajo=mc.get(1);
			MateriaClase.idClaseDeTrabajo=mc.get(2);
			MateriaClase.idNivelDeTrabajo=mc.get(3);
			MateriaClase.idTituloDeTrabajo=mc.get(4);
			MateriaClase.idEnsenanzaDeTrabajo=mc.get(5);
			Parcial.defParciales();
			Fecha.actualizarDiasNoLectivosClase();
			//Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(),true);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateriaClase+") fin");
	}
	public static void fijarMateriaClaseParaMateria(String idMateria, String idClase) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+")");
		Vector<String> mc = BBDD.consultarIdMateriaClaseParaMateria(idMateria,idClase);
		//BBDD.imprimirRegistro(mc);
		if (mc==null || mc.size()==0) {
			MateriaClase.idMateriaClaseDeTrabajo=null;
			MateriaClase.idMateriaDeTrabajo=null;
			MateriaClase.idClaseDeTrabajo=null;
			MateriaClase.idNivelDeTrabajo=null;
			MateriaClase.idTituloDeTrabajo=null;
			MateriaClase.idEnsenanzaDeTrabajo=null;
			Parcial.defParciales();
			Fecha.actualizarDiasNoLectivosClase();
			//Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(),false);
		} else {
			MateriaClase.idMateriaClaseDeTrabajo=mc.get(0);
			MateriaClase.idMateriaDeTrabajo=mc.get(1);
			MateriaClase.idClaseDeTrabajo=mc.get(2);
			MateriaClase.idNivelDeTrabajo=mc.get(3);
			MateriaClase.idTituloDeTrabajo=mc.get(4);
			MateriaClase.idEnsenanzaDeTrabajo=mc.get(5);
			Parcial.defParciales();
			Fecha.actualizarDiasNoLectivosClase();
			//Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(),true);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+") end");
	}
	public static void fijarMateriaClaseParaClase(String idMateria, String idClase) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+")");
		Vector<String> mc = BBDD.consultarIdMateriaClaseParaClase(idMateria,idClase);
		//BBDD.imprimirRegistro(mc);
		if (mc==null || mc.size()==0) {
			MateriaClase.idMateriaClaseDeTrabajo=null;
			MateriaClase.idMateriaDeTrabajo=null;
			MateriaClase.idClaseDeTrabajo=null;
			MateriaClase.idNivelDeTrabajo=null;
			MateriaClase.idTituloDeTrabajo=null;
			MateriaClase.idEnsenanzaDeTrabajo=null;
			Parcial.defParciales();
			Fecha.actualizarDiasNoLectivosClase();
			//Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(),false);
		} else {
			MateriaClase.idMateriaClaseDeTrabajo=mc.get(0);
			MateriaClase.idMateriaDeTrabajo=mc.get(1);
			MateriaClase.idClaseDeTrabajo=mc.get(2);
			MateriaClase.idNivelDeTrabajo=mc.get(3);
			MateriaClase.idTituloDeTrabajo=mc.get(4);
			MateriaClase.idEnsenanzaDeTrabajo=mc.get(5);
			Parcial.defParciales();
			Fecha.actualizarDiasNoLectivosClase();
			//Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(),true);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+") end");
	}
	public static int llevaMateriaClase(Calendar hasta){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((hasta!=null)?Fecha.formaFechaDiaHora(hasta):null)+")",false);
		Integer llevo=0;
		if (hasta!=null && Parcial.numeroParciales()>0){
			Vector<Vector<String>> uhorarias = BBDD.consultarUHMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo());
			if (uhorarias!=null) if (uhorarias.size()>0) {
				//System.out.println("MateriaClase fechaDuracionMateriaClase ("+minutos+","+idMateria+","+idClase+") uhs = "+uhorarias.size());
				Vector<Integer> duracionDia = new Vector<Integer>();
				for (int i=0;i<Fecha.NDiasSemana;i++) duracionDia.add(0);
				for (int i=0;i<uhorarias.size();i++) {
					Calendar fi = Fecha.hora(uhorarias.get(i).get(2), uhorarias.get(i).get(3));
					Calendar ff = Fecha.hora(uhorarias.get(i).get(4), uhorarias.get(i).get(5));
					int tmp=duracionDia.get(Integer.valueOf(uhorarias.get(i).get(1)));
					tmp=tmp+(int)(ff.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
					//System.out.println("MateriaClase duracionMateriaClase ff = "+ff.getTimeInMillis()+" fi = "+fi.getTimeInMillis());
					duracionDia.set(Integer.valueOf(uhorarias.get(i).get(1)), tmp);
				}
				Calendar fecha=Fecha.fechaHoraCero(Parcial.getFechaInicioParcial(1));
				Calendar fechaLimite=Fecha.fechaHoraCero(hasta);
				boolean llegoAlDia=false;
				for (int i=1;i<=Parcial.numeroParciales() && !llegoAlDia;i++) {
					while (fecha.compareTo(Parcial.getFechaFinParcial(i))<0 && !llegoAlDia){
						if (Fecha.diaLaboral(fecha,true)) {
							if (fecha.compareTo(fechaLimite)>=0) llegoAlDia=true;
							else llevo+=duracionDia.get(fecha.get(Calendar.DAY_OF_WEEK));
						}
						//System.out.println("MateriaClase llevoMateriaClase fecha "+Fecha.formaFechaDiaHora(fecha)+" <= "+Fecha.formaFechaDiaHora(Parcial.getFechaFinParcial(i))+" d"+llevo);
						if (!llegoAlDia) fecha.add(Calendar.DAY_OF_MONTH, 1);
					}
					if (i<Parcial.numeroParciales() && !llegoAlDia) fecha = (Calendar) Parcial.getFechaInicioParcial(i+1).clone();
				}
				for (int i=0;i<uhorarias.size();i++) {
					if (Integer.valueOf(uhorarias.get(i).get(1))==fecha.get(Calendar.DAY_OF_WEEK)) {
						Calendar fh = Fecha.hora(hasta.get(Calendar.HOUR_OF_DAY), hasta.get(Calendar.MINUTE));
						Calendar fi = Fecha.hora(uhorarias.get(i).get(2), uhorarias.get(i).get(3));
						Calendar ff = Fecha.hora(uhorarias.get(i).get(4), uhorarias.get(i).get(5));
						if (fh.compareTo(ff)<0) {
							Integer dih=(int)(fh.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
							llevo+=dih;
							break;
						} else {
							Integer dHU=(int)(ff.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
							llevo+=dHU;
						}
						//System.out.println("MateriaClase fechaDuracionMateriaClase fecha "+Fecha.formaFechaDiaHora(fecha)+" <= d"+llevo);
					}
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((hasta!=null)?Fecha.formaFechaDiaHora(hasta):null)+") "+llevo+" minutos",true);
		return llevo;
	}
	public static Calendar fechaDuracionMateriaClase(Integer minutos){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+minutos+") partials="+Parcial.numeroParciales(),false);
		Calendar fecha=null;
		Vector<Vector<String>> uhorarias = null;
		if (Parcial.numeroParciales()>0) {
			uhorarias = BBDD.consultarUHMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo());
			if (uhorarias!=null) if (uhorarias.size()>0) {
				//System.out.println("MateriaClase fechaDuracionMateriaClase ("+minutos+","+idMateria+","+idClase+") uhs = "+uhorarias.size());
				Vector<Integer> duracionDia = new Vector<Integer>();
				for (int i=0;i<Fecha.NDiasSemana;i++) duracionDia.add(0);
				for (int i=0;i<uhorarias.size();i++) {
					Calendar fi = Fecha.hora(uhorarias.get(i).get(2), uhorarias.get(i).get(3));
					Calendar ff = Fecha.hora(uhorarias.get(i).get(4), uhorarias.get(i).get(5));
					int tmp=duracionDia.get(Integer.valueOf(uhorarias.get(i).get(1)));
					tmp=tmp+(int)(ff.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
					//System.out.println("MateriaClase duracionMateriaClase ff = "+ff.getTimeInMillis()+" fi = "+fi.getTimeInMillis());
					duracionDia.set(Integer.valueOf(uhorarias.get(i).get(1)), tmp);
				}
				fecha=(Calendar)Parcial.getFechaInicioParcial(1).clone();
				fecha=Fecha.fechaHoraCero(fecha);
				boolean llegoAlDia=false;
				Integer llevo=0;
				for (int i=1;i<=Parcial.numeroParciales() && !llegoAlDia;i++) {
					while (fecha.compareTo(Parcial.getFechaFinParcial(i))<0 && !llegoAlDia){
						if (Fecha.diaLaboral(fecha,true)) {
							if (llevo+duracionDia.get(fecha.get(Calendar.DAY_OF_WEEK))>minutos) llegoAlDia=true;
							else llevo+=duracionDia.get(fecha.get(Calendar.DAY_OF_WEEK));
						}
						//System.out.println("MateriaClase fechaDuracionMateriaClase fecha "+Fecha.formaFechaDiaHora(fecha)+" <= "+Fecha.formaFechaDiaHora(Parcial.getFechaFinParcial(i))+" d"+llevo);
						if (!llegoAlDia) fecha.add(Calendar.DAY_OF_MONTH, 1);
					}
					if (i<Parcial.numeroParciales() && !llegoAlDia) fecha = (Calendar) Parcial.getFechaInicioParcial(i+1).clone();
				}
				for (int i=0;i<uhorarias.size();i++) {
					if (Integer.valueOf(uhorarias.get(i).get(1))==fecha.get(Calendar.DAY_OF_WEEK)) {
						Calendar fi = Fecha.hora(uhorarias.get(i).get(2), uhorarias.get(i).get(3));
						Calendar ff = Fecha.hora(uhorarias.get(i).get(4), uhorarias.get(i).get(5));
						Integer dHU=(int)(ff.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
						if (llevo+dHU>minutos) {
							fecha.set(Calendar.HOUR_OF_DAY, Integer.valueOf(uhorarias.get(i).get(2)));
							fecha.set(Calendar.MINUTE, Integer.valueOf(uhorarias.get(i).get(3)));
							fecha.add(Calendar.MINUTE, minutos-llevo);
							break;
						} else {
							llevo+=dHU;
						}
						//System.out.println("MateriaClase fechaDuracionMateriaClase fecha "+Fecha.formaFechaDiaHora(fecha)+" <= d"+llevo);
					}
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+minutos+") partials="+Parcial.numeroParciales()+" uhs="+((uhorarias!=null)?uhorarias.size():null)+" => "+Fecha.formaFechaDiaHora(fecha),true);
		return fecha;
	}
	public static Integer disponibleMateriaClase(Calendar desde){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((desde==null)?"null":Fecha.formaFechaDiaHora(desde))+") materiaclase ["+MateriaClase.getIdMateriaClaseDeTrabajo()+"]",false);
		Integer duracion=0;
		Vector<Vector<String>> uhorarias = BBDD.consultarUHMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo());
		if (uhorarias!=null) if (uhorarias.size()>0 && Parcial.numeroParciales()>0) {
			//System.out.println("MateriaClase duracionMateriaClase ("+idMateria+","+idClase+","+Fecha.formaFechaDiaHora(desde)+") uhs = "+uhorarias.size());
			Vector<Integer> duracionDia = new Vector<Integer>();
			for (int i=0;i<Fecha.NDiasSemana;i++) duracionDia.add(0);
			for (int i=0;i<uhorarias.size();i++) {
				Calendar fi = Fecha.hora(uhorarias.get(i).get(2), uhorarias.get(i).get(3));
				Calendar ff = Fecha.hora(uhorarias.get(i).get(4), uhorarias.get(i).get(5));
				int tmp=duracionDia.get(Integer.valueOf(uhorarias.get(i).get(1)));
				tmp=tmp+(int)(ff.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
				//System.out.println("MateriaClase duracionMateriaClase ff = "+ff.getTimeInMillis()+" fi = "+fi.getTimeInMillis());
				duracionDia.set(Integer.valueOf(uhorarias.get(i).get(1)), tmp);
			}
			for (int i=0;i<duracionDia.size();i++) {
				//System.out.println("MateriaClase duracionMateriaClase dia = "+i+": "+duracionDia.get(i)+" minutos.");
			}
			Calendar fecha;
			if (desde==null) {
				fecha=(Calendar)Parcial.getFechaInicioParcial(1).clone();
				fecha=Fecha.fechaHoraCero(fecha);
			} else {
				Vector<Vector<String>> uhs = BBDD.consultarUHMateriaClaseDiaDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(),desde);
				fecha=Fecha.hora(String.valueOf(desde.get(Calendar.HOUR_OF_DAY)),String.valueOf(desde.get(Calendar.MINUTE)));
				int tmp=0;
				Calendar hhi=null;
				for (int i=0;i<uhs.size();i++) {
					Calendar hi = Fecha.hora(uhs.get(i).get(1), uhs.get(i).get(2));
					Calendar hf = Fecha.hora(uhs.get(i).get(3), uhs.get(i).get(4));
					if (hi.compareTo(fecha)<0) hhi=fecha; else hhi=hi;
					tmp=tmp+(int)(hf.getTimeInMillis()-hhi.getTimeInMillis())/(60 * 1000);
				}
				duracion+=tmp;
				fecha=(Calendar)desde.clone();
				fecha.add(Calendar.DAY_OF_MONTH, 1);
				fecha=Fecha.fechaHoraCero(fecha);
			}
			for (int i=Parcial.getParcial(fecha);i<=Parcial.numeroParciales();i++) {
				while (fecha.compareTo(Parcial.getFechaFinParcial(i))<0){
					if (Fecha.diaLaboral(fecha,true)) duracion+=duracionDia.get(fecha.get(Calendar.DAY_OF_WEEK));
					//System.out.println("MateriaClase duracionMateriaClase fecha "+Fecha.formaFechaDiaHora(fecha)+" <= "+Fecha.formaFechaDiaHora(Parcial.getFechaFinParcial(i))+" d"+duracion);
					fecha.add(Calendar.DAY_OF_MONTH, 1);
				}
				if (i<Parcial.numeroParciales()) fecha = (Calendar) Parcial.getFechaInicioParcial(i+1).clone();
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((desde==null)?"null":Fecha.formaFechaDiaHora(desde))+") "+duracion+" minutos.",true);
		return duracion;
	}
}
