/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.widgets.Combo;

public class UHCombo {
	private Combo combo=null;
	private Vector<String> identificadores = new Vector<String>();
	public UHCombo(Combo combo){this.combo=combo;}
	public void rellenaUHMateriaClaseDesdeHora(String idMateriaClase,Calendar fecha,String idUH){
		if (combo!=null && idMateriaClase!=null && fecha!=null) {
			int diaSemana=fecha.get(Calendar.DAY_OF_WEEK);
			String idAntiguo = ((this.combo.getSelectionIndex()>=0)?(String)this.identificadores.get(this.combo.getSelectionIndex()):null);
			this.borrar();
			Vector<Vector<String>> uhs = new Vector<Vector<String>>();
			uhs = BBDD.consultarUHOrdenadaMateriaClase(idMateriaClase,diaSemana);
			boolean idDesde=((idUH==null)?true:false);
			//System.out.println(" UHCombo rellenarMateria ("+idMateria+") = "+Fecha.formaFechaDiaHora(fecha)+" desde id "+idUH+"("+idDesde+")");
			for (int i=0;i<uhs.size();i++) {
				if (uhs.get(i).get(0).equals(idUH) && idDesde==false) idDesde=true;
				//System.out.println("  UH ("+uhs.get(i).get(0)+") "+Fecha.formaUHoraria(uhs.get(i).get(1),uhs.get(i).get(2),uhs.get(i).get(3),uhs.get(i).get(4)));
				if (idDesde) {
					combo.add(Fecha.formaUHoraria(uhs.get(i).get(1),uhs.get(i).get(2),uhs.get(i).get(3),uhs.get(i).get(4)));
					identificadores.add(uhs.get(i).get(0));
					//System.out.println("   Añadiendo: "+Fecha.formaUHoraria(uhs.get(i).get(1),uhs.get(i).get(2),uhs.get(i).get(3),uhs.get(i).get(4)));
				}
			}
			if (idAntiguo!=null) this.seleccionarId(idAntiguo); else combo.select(0);
		}
	}
	public void borrar(){combo.removeAll();identificadores.clear();}
	public void seleccionarId(String idUH){
		combo.select(identificadores.indexOf(idUH));
		//System.out.println("UHCombo seleccinar "+idUH+" seleccionado = "+combo.getSelectionIndex());
		if (combo.getSelectionIndex()<0) combo.select(0);
	}
	public Combo getCombo(){return this.combo;}
	public String idSelecionado(){return ((combo.getSelectionIndex()>=0)?identificadores.get(combo.getSelectionIndex()):null);}
}
